-- main for transition.love

function love.load()
	gr, li, lf	= love.graphics, love.image, love.filesystem
	transitions = lf.enumerate('transitions')
	transIndex	= 1
	transition	= gr.newImage('transitions/' .. transitions[transIndex])
	image		= gr.newImage('flower.png')--'test.jpg')

	effect = gr.newPixelEffect [[
		extern Image  trans;
		extern float time;
		extern number duration;
		vec4 effect(vec4 color,Image tex,vec2 tc,vec2 pc)
		{	vec4 canv_color = Texel(tex,tc);
			//tc.y = 1-tc.y; // y-axis is flipped for masks (not essential)
			vec4 trans_color    = Texel(trans,tc);
			number white_level	= (trans_color.r + trans_color.b + trans_color.b)/3;
			number max_white	= time/duration;
			if (white_level     <= max_white) { return canv_color;};
			canv_color.a        = 0;
			//return canv_color;
			return trans_color;
		}
		]]

	t = 0
	duration = 3
	effect:send( 'duration', duration )
	effect:send( 'trans', transition )
	end

function love.draw()
	gr.setPixelEffect( effect )
	gr.draw( image )
	gr.setPixelEffect()
	gr.print(love.timer.getFPS(),gr.getWidth()-30,10)
	gr.print( transitions[transIndex], 10, 10 )
	end

function love.update(dt)
	t = t + dt
	effect:send("time",t)
	end

function love.keypressed(key)
	if key == 'r' then t = 0 end
	if key == 'd' then duration = duration + .2 effect:send( 'duration', duration ) end
	if key == 'f' then duration = duration - .2 effect:send( 'duration', duration ) end
	if key == 'escape'	then love.event.push( 'quit' )	end
	if key == 'left' or key == 'right' then
		if key == 'left' then
			transIndex = transIndex>2 and transIndex - 1 or #transitions
		elseif key == 'right' then
			transIndex = transIndex < #transitions and transIndex + 1 or 1
		end
		transition = gr.newImage('transitions/' .. transitions[transIndex])
		effect:send("trans",transition)
		t = 0
		end
	end
